package com.xisc.pm.app.service.imports;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.xisc.pm.domain.entity.PmPlateSpecYieldBt;
import com.xisc.pm.domain.entity.PmPlateSpecYieldBtTra;
import com.xisc.pm.domain.repository.PmPlateSpecYieldBtRepository;
import com.xisc.pm.domain.repository.PmPlateSpecYieldBtTraRepository;
import io.choerodon.core.exception.CommonException;
import io.choerodon.core.oauth.DetailsHelper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.hzero.boot.imported.app.service.IBatchImportService;
import org.hzero.boot.imported.infra.validator.annotation.ImportService;
import org.springframework.beans.BeanUtils;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author 纪文桃 wentao.ji01@hand-china.com
 * @since 2024/7/25 14:49
 */
@Slf4j
@ImportService(templateCode = "PM.PLATE_SPEC_YIELD_BT")
public class PmPlateSpecYieldBtImportImpl implements IBatchImportService {

    private final ObjectMapper objectMapper;

    private final PmPlateSpecYieldBtRepository pmPlateSpecYieldBtRepository;

    private final PmPlateSpecYieldBtTraRepository pmPlateSpecYieldBtTraRepository;

    public PmPlateSpecYieldBtImportImpl(ObjectMapper objectMapper, PmPlateSpecYieldBtRepository pmPlateSpecYieldBtRepository, PmPlateSpecYieldBtTraRepository pmPlateSpecYieldBtTraRepository) {
        this.objectMapper = objectMapper;
        this.pmPlateSpecYieldBtRepository = pmPlateSpecYieldBtRepository;
        this.pmPlateSpecYieldBtTraRepository = pmPlateSpecYieldBtTraRepository;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean doImport(List<String> data) {
        // 如果集合为空，则返回
        if (CollectionUtils.isEmpty(data)) {
            throw new CommonException("pm.import_data_is_empty_list");
        }
        // 获取租户id和当前时间以及用户信息
        Long tenantId = 0L;
        Date now = new Date();
        String username = DetailsHelper.getUserDetails().getUsername();
        if (DetailsHelper.getUserDetails() != null && DetailsHelper.getUserDetails().getTenantId() != null) {
            tenantId = DetailsHelper.getUserDetails().getTenantId();
        }
        // 定义要插入的List
        List<PmPlateSpecYieldBt> list = new ArrayList<>(data.size());
        List<PmPlateSpecYieldBtTra> tralist = new ArrayList<>(data.size());

        // 数据转对象
        for (String json : data) {
            try {
                PmPlateSpecYieldBt plateSpecYieldBt = objectMapper.readValue(json, PmPlateSpecYieldBt.class);
                plateSpecYieldBt.setTenantId(tenantId);
                list.add(plateSpecYieldBt);

            } catch (JsonProcessingException e) {
                log.error(e.getMessage(), e);
            }
        }

        // 如果集合为空，则结束
        if (CollectionUtils.isEmpty(list)) {
            throw new CommonException("pm.import_data_is_empty_list");
        }
        // 插入表
        pmPlateSpecYieldBtRepository.batchInsertSelective(list);

        // 获取履历表数据
        for (PmPlateSpecYieldBt pmPlateSpecYieldBt : list) {
            PmPlateSpecYieldBtTra plateSpecYieldBtTra = new PmPlateSpecYieldBtTra();
            BeanUtils.copyProperties(pmPlateSpecYieldBt, plateSpecYieldBtTra);
            // 设置操作类型为新增（I），并记录操作时间和用户
            plateSpecYieldBtTra.setOperationType("I");
            plateSpecYieldBtTra.setOperationTime(now);
            plateSpecYieldBtTra.setOperationUser(username);
            tralist.add(plateSpecYieldBtTra);
        }
        // 插入履历表
        pmPlateSpecYieldBtTraRepository.batchInsertSelective(tralist);
        return true;
    }
}
